{
    This file is part of the Web Service Toolkit
    Copyright (c) 2006 by Inoussa OUEDRAOGO

    This file is provide under LGPL licence which can be found at
    http://www.gnu.org/licenses/lgpl.html.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
}

unit http_call_handler;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  formaterintf, basestubimp,
  IdHTTP;
  
Type

  { THttpRemoteCallMaker }

  THttpRemoteCallMaker = class(TAbstractRemoteCallMaker)
  Private
    FConnection : TidHttp;
  Public
    constructor Create();override;
    destructor Destroy();override;
    procedure MakeCall(ASerializer : TAbstractFormatter);override;
  End;


implementation
uses type_registry, xml_formater;
{ THttpRemoteCallMaker }

constructor THttpRemoteCallMaker.Create();
begin
  FConnection := TidHttp.Create(Nil);
end;

destructor THttpRemoteCallMaker.Destroy();
begin
  FConnection.Free();
  inherited Destroy();
end;

{procedure THttpRemoteCallMaker.MakeCall(ASerializer: TAbstractFormatter);
Var
  rqt, rsps : TMemoryStream;
  s : string;
  i : Integer;
begin
  rsps := Nil;
  rqt := TMemoryStream.Create();
  Try
    rsps := TMemoryStream.Create();
    ASerializer.SaveToStream(rqt);

    SetLength(s,rqt.Size);
    Move(rqt.Memory^,s[1],rqt.Size);
    WriteLn('');WriteLn(s);

    FConnection.Request.ContentType := 'text/xml';
    FConnection.Post(ASerializer.GetCallAdress(),rqt,rsps);
    rsps.Position := 0;
    ASerializer.Clear();
    ASerializer.LoadFromStream(rsps);
  Finally
    i := rsps.Size;
    SetLength(s,i);
    Move(rsps.Memory^,s[1],i);
    WriteLn('');WriteLn(s);
    
    rsps.Free();
    rqt.Free();
  End;
end;}

procedure THttpRemoteCallMaker.MakeCall(ASerializer: TAbstractFormatter);
Var
  rqt, rsps : TMemoryStream;
begin
  rsps := Nil;
  rqt := TMemoryStream.Create();
  Try
    rsps := TMemoryStream.Create();
    ASerializer.SaveToStream(rqt);
    rqt.Position := 0;
    FConnection.Request.ContentType := 'text/xml';
    FConnection.Post(ASerializer.GetCallAdress(),rqt,rsps);
    rsps.Position := 0;
    ASerializer.Clear();
    ASerializer.LoadFromStream(rsps);
  Finally
    rsps.Free();
    rqt.Free();
  End;
end;

Initialization
  GetRemoteCallMakerRegistry().Register('HTTP',THttpRemoteCallMaker);
  GetTypeRegistry().Add(TTypeRegistryItem.Create(sXSD_NS,TypeInfo(Integer),'int'));
  GetTypeRegistry().Add(TTypeRegistryItem.Create(sXSD_NS,TypeInfo(string),'string'));
  GetTypeRegistry().Add(TTypeRegistryItem.Create(sXSD_NS,TypeInfo(boolean),'boolean'));
  
end.
