{Copyright (c) 2006 by Inoussa OUEDRAOGO}
program ws_helper;

{$mode objfpc}{$H+}

uses
  Classes, SysUtils,
  parserdefs, ws_parser, generator, parserutils;

resourcestring
  sUSAGE = 'SoapHelper inputFilename';
  sCOPYRIGHT = 'SoapHelper Copyright (c) 2006 by Inoussa OUEDRAOGO';

Var
  inFileName,errStr : string;

  function ProcessCmdLine():boolean;
  begin
    inFileName := ParamStr(1);
    Result := FileExists(inFileName);
    If Not Result Then
      errStr := Format('File not Found : "%s"',[inFileName]);
  end;

  function ProcessFile():Boolean;
  Var
    p : TPascalParser;
    s,df : TFileStream;
    g : TGenerator;
    locOutFileName : String;
  begin
     Result := False;
     df := Nil;
     g := Nil;
     s := Nil;
     p := Nil;
    Try
      Try
        s := TFileStream.Create(inFileName,fmOpenRead);
        p := TPascalParser.Create(s);
        If Not p.Parse() Then
          p.Error(p.ErrorMessage);
        g := TGenerator.Create(p.SymbolTable);
        g.Execute();
        locOutFileName := ExtractFilePath(inFileName) + g.GetDestUnitName() + '.pas';
        If FileExists(locOutFileName) Then
          DeleteFile(locOutFileName);
        df := TFileStream.Create(locOutFileName,fmCreate);
        g.GetData(df);
        Result := True;
      Except
        On E : Exception Do Begin
          Result := False;
          errStr := Format('"%s" at line %d',[E.Message,p.SourceLine]) ;
        End;
      End;
    Finally
      df.Free();
      g.Free();
      p.Free();
      s.Free();
    End;
  end;

begin
  Writeln(sCOPYRIGHT);
  If ( ParamCount = 0 ) Then Begin
    WriteLn(sUSAGE);
    Exit;
  End;

  If Not ProcessCmdLine() Then Begin
    WriteLn(errStr);
    Exit;
  End;

  If Not ProcessFile() Then Begin
    WriteLn(errStr);
    Exit;
  End;
  WriteLn(Format('File "%s" parsed succesfully.',[inFileName]));
end.
